package fr.username404.snowygui.mixins;

import fr.username404.snowygui.gui.feature.Zoom;
import net.minecraft.client.Options;
import net.minecraft.client.renderer.GameRenderer;
import org.objectweb.asm.Opcodes;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Redirect;

@Mixin(GameRenderer.class)
abstract class ZoomMixin {
	@Redirect(
		at = @At(value = "FIELD", target = "Lnet/minecraft/client/Options;fov:D", opcode = Opcodes.GETFIELD, ordinal = 0),
		method = "getFov(Lnet/minecraft/client/Camera;FZ)D"
	)
	private double getFov(Options options) {
		return Zoom.INSTANCE.getToggled() ? Zoom.getNewZoom(options.fov) : options.fov;
	}
}
